class GRAPH_MATRIX {
    public KNOTEN[] knotenfeld;     //0: Fulda
    public int[][] adjazenzmatrix;  //0te Reihe und 0te Spalte Fulda
    public boolean[] besucht;       //sonst rennt man im Kreis
    //Nice to have
    public int anzahlKnoten;
    public int maxAnzahlKnoten;

    //BruteForce Variablen fr die Wege
    public final int infinity = Integer.MAX_VALUE;
    public String aktWeg = "";
    public int aktLaenge = 0;

    // Konstruktor
    public GRAPH_MATRIX(int maxAnzahlKnoten) {
        anzahlKnoten = 0; //Zhlt die bereits vorhandenen Knoten
        knotenfeld = new KNOTEN[maxAnzahlKnoten];
        besucht = new boolean[maxAnzahlKnoten];
        adjazenzmatrix = new int[maxAnzahlKnoten][maxAnzahlKnoten];
        this.maxAnzahlKnoten = maxAnzahlKnoten; 

        //Die Adjazenzmatrix wird mit den Werten 0 auf der Diagonalen,
        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            for(int j=0; j < maxAnzahlKnoten; j=j+1) {
                if(i == j) { //Diagonale mit Nullen belegen
                    adjazenzmatrix[i][j] = 0;
                } else {
                    adjazenzmatrix[i][j] = 0;
                }
            }
        }
    }

    public int knotenHinzufuegen(DATENELEMENT newDaten){
        int i=0;
        for (;i< maxAnzahlKnoten; i++){
            if(knotenfeld[i]==null) {
                knotenfeld[i]=new KNOTEN(newDaten);break;}
            else{
                if (knotenfeld[i].datenLiefern().ortsnameGeben() == newDaten.ortsnameGeben()){
                    System.out.println("Den Ort gibt es schon.");
                }
            }
        }
        return i;
    }

    public void kanteHinzufuegen(int start, int ziel, int laenge) {
        if (start >= 0 && ziel >= 0 && start!=ziel &&  start < maxAnzahlKnoten && ziel < maxAnzahlKnoten) {
            //erste Reihe, dann Spalte
            adjazenzmatrix[start][ziel] = laenge;
            adjazenzmatrix[ziel][start] = laenge;
        }
    }

    public void matrixAusgeben() {
        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            for(int j=0; j < maxAnzahlKnoten; j=j+1) {
                System.out.print(adjazenzmatrix[i][j]+"  ");
            }
            System.out.println();
        }
    }

    public void matrixAusgebenVerbindungen() {
        //Oberste Reihe
        System.out.print("\t");
        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            System.out.print(knotenfeld[i].daten.ortsname.substring(0, 2) +"\t");
        }
        System.out.println();
        //Restlichen Reihen
        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            System.out.print(knotenfeld[i].daten.ortsname.substring(0, 2) +"\t");
            for(int j=0; j < maxAnzahlKnoten; j=j+1) {
                System.out.print(adjazenzmatrix[i][j]+"\t");
            }
            System.out.println();
        }
    }

    public void tiefensucheSchritt(int knotenIdx) {
        //Hier weiterprogrammieren

        //Aktuellen Knoten auf besucht=true setzen, sonst laufe ich im Kreis - eventuell.
        besucht[knotenIdx]=true;
        System.out.println(knotenfeld[knotenIdx].daten.ortsname);

        //Wo geht es als nchstes hin?
        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            if (adjazenzmatrix[knotenIdx][i] > 0 && besucht[i]==false) {
                tiefensucheSchritt(i);
            }
        }
    }

    public void tiefensuche(int startKnotenIdx) {
        //Hier weiterprogrammieren   
        //Zurcksetzen der Attribute

        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            besucht[i]=false;
        }

        //Eigentliche Start der Teifensuche
        tiefensucheSchritt(startKnotenIdx);
    }

    public boolean istZusammenhaengend() {
        boolean ergebnis=false;
        //Einmal die Tiefensuche durchlaufen lassen

        //Prfen, ob alle Knoten besucht wurden

        return ergebnis;
    }

    //BruteForce
    //Teste jeden mglichen Pfad, den ich laufen kann und messe die Lnge. Der krzeste Pfad gewinnt.

    public void ablaufen(int aktKnotenIdx,int zielKnotenIdx, String pfad, int laenge) {
        String neuerPfad = "";
        int neueLange = 0;
        //Hier weiterprogrammieren 
        besucht[aktKnotenIdx]=true;

        if(aktKnotenIdx!=zielKnotenIdx) { //Noch nicht im Zielknoten
            //Wo geht es als nchstes hin?
            for(int i=0; i < maxAnzahlKnoten; i=i+1) {
                if (adjazenzmatrix[aktKnotenIdx][i] > 0 && besucht[i]==false) {
                    neuerPfad = pfad + "/" + knotenfeld[i].daten.ortsname;
                    neueLange = laenge + adjazenzmatrix[aktKnotenIdx][i];
                    ablaufen(i, zielKnotenIdx, neuerPfad, neueLange );
                }
            }
        } else {
            //Ziel erreicht
            System.out.println("Ziel erreicht");
            System.out.println(pfad+" mit "+laenge+" km");
            
            if(laenge<aktLaenge) {
                aktWeg = pfad;
                aktLaenge = laenge;
            }
            
        }

        besucht[aktKnotenIdx]=false;
    }

    public void wegeSuchen(int startKnotenIdx,int zielKnotenIdx) {
        //Hier weiterprogrammieren    

        //Zurcksetzen der Attribute
        aktWeg = "";
        aktLaenge = infinity;

        for(int i=0; i < maxAnzahlKnoten; i=i+1) {
            besucht[i]=false;
        }

        //Eigentliche Start der Teifensuche
        ablaufen(startKnotenIdx, zielKnotenIdx, knotenfeld[startKnotenIdx].daten.ortsname, 0 );
        
        //Ausgabe des besten Knoten
        System.out.println("\n\nSchnellster Weg");
        System.out.println(aktWeg+" mit "+aktLaenge+" km");
    }

}